package fr.univlyon1.tiw1.inscriptions;

import fr.univlyon1.tiw1.inscriptions.modele.*;

import javax.inject.Inject;
import javax.jws.WebMethod;
import javax.jws.WebService;
import javax.validation.constraints.NotNull;
import javax.xml.ws.WebFault;
import java.util.Collection;

/**
 * Created by ecoquery on 19/10/2016.
 */
@WebService(endpointInterface = "fr.univlyon1.tiw1.inscriptions.InscriptionsService", targetNamespace = Constants.SERVICE_NAMESPACE)
public class InscriptionsServiceImpl {

    private InscriptionsDAO dao;

    @Inject
    public void setDao(InscriptionsDAO dao) {
        this.dao = dao;
    }

    public Person metAJourPersonne(@NotNull Person person) {
        return dao.createOrUpdate(person);
    }

    public Collection<Event> evenements() {
        return dao.getAllEvents();
    }

    public boolean inscrire(@NotNull String email, @NotNull String titreEvenement) throws EvenementInconnuException {
        Person p = new Person();
        p.setEmail(email);
        p = dao.createOrUpdate(p);
        Event e = dao.getEventByName(titreEvenement);
        p.inscrire(e);
        return true;
    }
}
