package fr.univlyon1.tiw1.inscriptions;

import fr.univlyon1.tiw1.inscriptions.modele.Event;
import fr.univlyon1.tiw1.inscriptions.modele.Person;
import org.junit.Test;
import org.junit.runner.RunWith;
import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.test.context.ContextConfiguration;
import org.springframework.test.context.junit4.SpringJUnit4ClassRunner;
import org.springframework.transaction.annotation.Transactional;

import static org.junit.Assert.*;

/**
 * Created by ecoquery on 19/10/2016.
 */
@RunWith(SpringJUnit4ClassRunner.class)
@ContextConfiguration("/spring/beans.xml")
@Transactional
public class DAOTest {

    @Autowired
    private InscriptionsDAO dao;

    @Test
    public void testHasEvents() {
        assertEquals(dao.getAllEvents().size(),2);
    }

    @Test
    public void testCreateOrUpdatePerson() {
        Person p = dao.getPerson("dr.who@tardis.net");
        Person p2 = new Person();
        p2.setCompany("Tardis Inc");
        p2.setEmail(p.getEmail());
        p2.setName(p2.getName());
        p2 = dao.createOrUpdate(p2);
        assertTrue(p == p2);
        assertEquals(p.getCompany(),"Tardis Inc");
        p = new Person();
        p.setEmail("toto.cyber@man.net");
        p = dao.createOrUpdate(p);
        assertEquals(p.getName(),"Toto");
        assertEquals(p.getInscriptions().size(),1);
    }

    @Test
    public void testGetEventByName() {
        try {
            assertNotNull(dao.getEventByName("Formation SI entreprises"));
        } catch (EvenementInconnuException e) {
            fail("evenement non trouvé");
        }
        try {
            dao.getEventByName("n'existe pas");
        } catch (EvenementInconnuException e) {

        }

    }

}
